------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--   P O L Y O R B . S E T U P . T A S K I N G . F U L L _ T A S K I N G    --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--         Copyright (C) 2002-2010, Free Software Foundation, Inc.          --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--                                                                          --
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

with PolyORB.Tasking.Profiles.Full_Tasking.Threads.Annotations;
pragma Unreferenced
         (PolyORB.Tasking.Profiles.Full_Tasking.Threads.Annotations);

with PolyORB.Tasking.Profiles.Full_Tasking.Threads.Static_Priorities;
pragma Unreferenced
         (PolyORB.Tasking.Profiles.Full_Tasking.Threads.Static_Priorities);

with PolyORB.Tasking.Profiles.Full_Tasking.Threads;
pragma Unreferenced (PolyORB.Tasking.Profiles.Full_Tasking.Threads);

with PolyORB.Tasking.Profiles.Full_Tasking.Mutexes;
pragma Unreferenced (PolyORB.Tasking.Profiles.Full_Tasking.Mutexes);

with PolyORB.Tasking.Profiles.Full_Tasking.Condition_Variables;
pragma Unreferenced
         (PolyORB.Tasking.Profiles.Full_Tasking.Condition_Variables);

with PolyORB.Tasking.Profiles.Full_Tasking_ATC.Abortables;
pragma Unreferenced (PolyORB.Tasking.Profiles.Full_Tasking_ATC.Abortables);

package body PolyORB.Setup.Tasking.Full_Tasking is

end PolyORB.Setup.Tasking.Full_Tasking;
